std::__debug::map< _Key, _Tp, _Compare, _Allocator > Class Template Reference
Inheritance diagram for std::__debug::map< _Key, _Tp, _Compare, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, map > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< _Base_iterator, map > | iterator
typedef _Compare | key_compare
typedef _Key | key_type
typedef _Tp | mapped_type
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef std::pair< const _Key, _Tp > | value_type

## Public Member Functions

template<typename _InputIterator >
| map (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
template<typename _InputIterator >
| map (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
| map (const _Base &__x)
| map (const _Compare &__comp, const _Allocator &__a=_Allocator())
| map (const allocator_type &__a)
| map (const map &)=default
| map (const map &__m, const allocator_type &__a)
| map (initializer_list< value_type > __l, const _Compare &__c=_Compare(), const allocator_type &__a=allocator_type())
| map (initializer_list< value_type > __l, const allocator_type &__a)
| map (map &&)=default
| map (map &&__m, const allocator_type &__a)
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
void | _M_invalidate_if (_Predicate __pred)
void | _M_swap (_Safe_container &__x) noexcept
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
std::pair< iterator, bool > | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
const_iterator | end () const noexcept
iterator | end () noexcept
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
std::pair< iterator, iterator > | equal_range (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
std::pair< const_iterator, const_iterator > | equal_range (const _Kt &__x) const
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | find (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | find (const _Kt &__x) const
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
std::pair< iterator, bool > | insert (_Pair &&__x)
std::pair< iterator, bool > | insert (const value_type &__x)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
iterator | insert (const_iterator __position, _Pair &&__x)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
void | insert (std::initializer_list< value_type > __list)
std::pair< iterator, bool > | insert (value_type &&__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | lower_bound (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | lower_bound (const _Kt &__x) const
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
map & | operator= (const map &)=default
map & | operator= (initializer_list< value_type > __l)
map & | operator= (map &&)=default
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | swap (map &__x) noexcept(/*conditional */)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | upper_bound (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | upper_bound (const _Kt &__x) const
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const

## Protected Member Functions

void | _M_invalidate_all ()
_Safe_container & | _M_safe () noexcept

## Detailed Description

### template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
class std::__debug::map< _Key, _Tp, _Compare, _Allocator >

Class std::map with safety/checking/debug instrumentation.

Definition at line 44 of file debug/map.h.

## Member Function Documentation

## _M_invalidate_if()

void __gnu_debug::_Safe_sequence< map< _Key, _Tp, std::less< _Key >, std::allocator< std::pair< const _Key, _Tp > > > >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 38 of file safe_sequence.tcc.

## _M_transfer_from_if()

void __gnu_debug::_Safe_sequence< map< _Key, _Tp, std::less< _Key >, std::allocator< std::pair< const _Key, _Tp > > > >::_M_transfer_from_if | ( | _Safe_sequence< map< _Key, _Tp, std::less< _Key >, std::allocator< std::pair< const _Key, _Tp > > > > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 69 of file safe_sequence.tcc.

The documentation for this class was generated from the following file:

- debug/map.h